//
//  Copyright (C) 1997,1998,1999 Forest Edge Software, All Rights Reserved
//
//  Program:    eVAX, a "Virtual VAX" for Mac OS Computers
//
//  Author:     Tom Cole
//
//  Module:     asmproto.h
//
//  Purpose:    Prototypes, defines, etc. for the assembler and it's support routines.
//
//  History:    07/28/97    New header format standardization
//              01/05/99    Added ASM_BRANCHDEST flag defintiion
//


//  D E F I N E S

#define ASM_ADDRPROMPT      0x00000001      /*  Show address as part of ASM  */
                                            /*      prompt?                  */
#define ASM_WARNFORWARD     0x00000002      /*  Warn if there are unresolved */
                                            /*      symbols after ASM END    */
#define ASM_PARSING_IDX     0x00000004      /*  Are we parsing an indexed    */
                                            /*      mode expression? Used to */
                                            /*      control recursion        */
#define ASM_BRANCHDEST      0x00000008      /*  Do we display destination    */
                                            /*      of branch in disasm?     */
#define ASM_EXPRESSION      0x00000010      /*  Are we parsing an expression */
                                            /*      versus scalar value?     */
#define ASM_SYMBOLS         0x00000020      /*  Display symbols in disasm?   */

#define ASM_RESTMP          0x00000040      /*  Require that temp symbols    */
                                            /*      resolve in scope         */

#define ASM_SYMDEBUG        0x00000080      /*  Symbol table debug?          */

#define ASM_SCOPENAMES      0x00000100      /*  Do we use scope names?       */

#define ASM_ENTRY           0x00000200      /*  Assembly includes __ENTRY    */

#define ASM_UNIQUE          0x00000400      /*  Must define unique symbol    */

//  P R O T O T Y P E S

long asm_operand( struct VAX * vax, char ** Buffptr );
long asm_reg( struct VAX * vax, char ch, char ** P, long *Value );
long asm_hex( struct VAX * vax, char ** P, unsigned long *Value );
long asm_dec( struct VAX * vax, char ** P, long *Value );
long asm_opcode( struct VAX * vax, char ** Buffptr, long * count );
long asm_pseudo( struct VAX * vax, char * Buffer );

long asm_value( struct VAX * vax, char ** P, unsigned long * V, long mode );
long asm_mask( struct VAX * vax, char ** P, long * V );
long asm_float( struct VAX * vax, char ** P );
long asm_expr( struct VAX * vax, char ** P, long * V );

long get_symbol(  struct VAX * vax, char ** symbol, long * value );
long set_symbol(  struct VAX * vax, char ** symbol, long value );
long clear_system_symbols( struct VAX * vax );
long clear_symbol(  struct VAX * vax, char * symbol );
long clear_all_symbols(  struct VAX * vax  );
long dump_symbols(  struct VAX * vax, int flag );
long dump_forward_references( struct VAX * vax, struct SYMBOL * p );
long check_unresolved_symbols( struct VAX * vax, int flag );
long dump_system_symbols(  struct VAX * vax );
long scope_symbols( struct VAX * vax );

long asm_symbol(  struct VAX * vax, char ** P, long *Value );
long asm_label( struct VAX * vax, char ** P );

long asm_function( struct VAX * vax, char * fname, char ** P, long * value );
