//
//	Copyright (C) 1997,1998,1999 Forest Edge Software, All Rights Reserved
//
//	Program:	eVAX, a "Virtual VAX" for Mac OS Computers
//
//	Author:		Tom Cole
//
//	Module:		console_proto.h
//
//	Purpose:	This header defines the prototypes for the command handlers
//				for the virtual VAX console.  They are kept separate here so
//				when a new command handler is added, only the console modules
//				need to be rebuilt.
//
//	History:	08/06/97	New header format standardization
//
//				09/24/98	Added CALL command
//


/*	Routine to execute a single command	*/

long console_dispatch( struct VAX ** Vax, char * cmd );
long console_dispatch_init( void );


/*	Routines for each specific command	*/

long console_init( struct VAX ** Vax, char ** P );
long console_zero( struct VAX ** Vax, char ** P );
long console_show( struct VAX ** Vax, char ** P );
long console_set( struct VAX ** Vax, char ** P );
long console_disasm( struct VAX ** Vax, char ** P );
long console_asm( struct VAX ** Vax, char ** P );
long console_exam( struct VAX ** Vax, char ** P );
long console_exec( struct VAX ** Vax, char ** P );
long console_quit( struct VAX ** Vax, char ** P );
long console_save( struct VAX ** vax, char ** p );
long console_clear( struct VAX ** vax, char ** p );
long console_step( struct VAX ** vax, char ** p );
long console_load( struct VAX ** vax, char ** p );
long console_time( struct VAX ** vax, char ** p );
long console_include( struct VAX ** vax, char ** p );
long console_asm( struct VAX ** vax, char ** P );
long console_print( struct VAX ** vax, char ** P );
long console_test( struct VAX ** vax, char ** P );
long console_vminit( struct VAX ** vax, char ** P );
long console_call( struct VAX ** vax, char ** P );
long console_do( struct VAX ** vax, char ** P );
long console_if( struct VAX ** vax, char ** P );
long console_boot( struct VAX ** vax, char ** P );
long console_run( struct VAX ** vax, char ** P );

/*
 *	Console support routines
 */

long save_binary( struct VAX * vax, char ** p );
long show_calls( struct VAX * vax, long count );

/*
 *	This data structure handles command dispatch
 */

typedef long (*console_handler)( struct VAX ** Vax, char ** p ) ;

struct CONSOLE_DISPATCH_TABLE {
	long	verb[ 3 ];
	console_handler handler;
};

long push_command( char * cmd );
